#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5 + 1;
vector<vector<pair<ll, ll>>> dp;
vector<ll> g[N];
ll n, k, t;
ll gg = 0;
ll ans[N];

void dfs(ll v, ll p) {
    ll tp = 0;
    for (ll u: g[v]) {
        if (u != p) {
            tp++;
            dfs(u, v);
            for (int s = 1; s < gg; ++s) {
                auto [cnt, r] = dp[u][s];
                auto &[cntv, rv] = dp[v][s];
                cntv += cnt;
                r--;
                if (rv == -1) {
                    rv = r;
                } else if (rv >= s - r) {
                    rv = max(rv, r);
                } else {
                    rv = min(rv, r);
                }
            }
        }
    }
    if (tp == 0) {
        for (int i = 1; i < gg; ++i) {
            dp[v][i].second = i - 1;
        }
    } else {
        for (int i = 1; i < gg; ++i) {
            if (dp[v][i].second == 0) {
                dp[v][i].first++;
                dp[v][i].second = i;
            }
        }
    }
}

void dfs1(ll v, ll p) {
    vector<ll> sum(gg);
    for (int s = 1; s < gg; ++s) {
        for(ll u: g[v]) {
            sum[s] += dp[u][s].first;
            if (s == dp[u][s].second) {
                sum[s]--;
            }
        }
    }
    for (int s = 1; s < gg; ++s) {
       if (sum[s] <= k) {
           ans[v] = s;
           break;
       }
    }
}

void solve() {
    cin >> n >> k >> t;
    gg = n / k + 5;
    dp.assign(n + 1, vector<pair<ll, ll>>(gg, {0, -1}));
    for (int i = 0; i < n - 1; ++i) {
        ll v, u;
        cin >> v >> u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    dfs(1, 0);
    dfs1(1, 0);
    cout << ans[1];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int test = 1;
    while (test--) {
        solve();
    }
    return 0;
}