#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 2e5 + 5;

ll p[N * 4];
ll cnt[N];

ll tin[N];
ll tout[N];
ll ld[N];
ll rd[N];
ll wd[N];
ll t = 1;

void push(ll v, ll tl, ll tr) {
    if (tl == tr) {
        cnt[tl] += p[v];
    } else {
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }
    p[v] = 0;
}

void add(ll v, ll tl, ll tr, ll l, ll r, ll c) {
    push(v, tl, tr);
    if (tl > r || tr < l || l > r) {
        return;
    }
    if (tl >= l && tr <= r) {
        p[v] += c;
        push(v, tl, tr);
        return;
    }
    ll tm = (tl + tr) / 2;
    add(v * 2, tl, tm, l, r, c);
    add(v * 2 + 1, tm + 1, tr, l, r, c);
}

void get(ll v, ll tl, ll tr, ll k, ll &ans) {
    push(v, tl, tr);
    if (tl > k || tr < k) {
        return;
    }
    if (tl == tr) {
        ans = cnt[tl];
        return;
    }
    ll tm = (tl + tr) / 2;
    get(v * 2, tl, tm, k, ans);
    get(v * 2 + 1, tm + 1, tr, k, ans);
}

ll now[N];

vector<ll> tree(N * 4, -2);

void ps(ll v, ll tl, ll tr) {
    if (tree[v] == -2) {
        return;
    }
    if (tl != tr) {
        tree[v * 2] = tree[v * 2 + 1] = tree[v];
    } else {
        now[tl] = tree[v];
    }
    tree[v] = -2;
}

void put(ll v, ll tl, ll tr, ll l, ll r, ll c) {
    ps(v, tl, tr);
    if (tl > r || tr < l || l > r) {
        return;
    }
    if (tl >= l && tr <= r) {
        tree[v] = c;
        ps(v, tl, tr);
        return;
    }
    ll tm = (tl + tr) / 2;
    put(v * 2, tl, tm, l, r, c);
    put(v * 2 + 1, tm + 1, tr, l, r, c);
}

void gt(ll v, ll tl, ll tr, ll k) {
    ps(v, tl, tr);
    if (tl > k || tr < k) {
        return;
    }
    if (tl == tr) {
        return;
    }
    ll tm = (tl + tr) / 2;
    gt(v * 2, tl, tm, k);
    gt(v * 2 + 1, tm + 1, tr, k);
}

ll mxh = 0;

void dfs(ll v, ll &s, ll h) {
    mxh = max(mxh, h);
    tin[v] = t++;
    wd[v] = 1;
    now[v] = -1;
    s++;
    cnt[tin[v]] = s;
    if (ld[v] != 0) {
        dfs(ld[v], s, h + 1);
        wd[v] += wd[ld[v]];
    }
    if (rd[v] != 0) {
        dfs(rd[v], s, h + 1);
        wd[v] += wd[rd[v]];
    }
    tout[v] = t++;
    cnt[tout[v]] = s;
}

ll dfs1(ll v, ll b, ll &s) {
    if (v == b) {
        return s;
    }
    gt(1, 0, N - 1, v);
    if (now[v] == -1) {
        s++;
    }
    if (ld[v] != 0 && tin[b] <= tout[ld[v]]) {
        return dfs1(ld[v], b, s);
    } else {
        if (now[v] == 0) {
            s++;
        }
        if (ld[v] != 0) {
            s += wd[ld[v]];
        }
        return dfs1(rd[v], b, s);
    }
}


void dfs2(ll v, ll &s) {
    gt(1, 0, N - 1, v);
    if (now[v] == -1) {
        s++;
        cnt[v] = s;
    }
    if (ld[v] != 0) {
        dfs2(ld[v], s);
    }
    if (now[v] == 0) {
        s++;
        cnt[v] = s;
    }
    if (rd[v] != 0) {
        dfs2(rd[v], s);
    }
    if (now[v] == 1) {
        s++;
        cnt[v] = s;
    }
}

struct node {
    ll l, r, x;
};

void solve() {
    ll n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> ld[i] >> rd[i];
    }
    ll root = 1;
    ll s = 0;
    dfs(root, s, 0);
    if (mxh <= 30) {
        for (int i = 0; i < q; ++i) {
            ll type;
            cin >> type;
            if (type == 1) {
                ll l, r, x;
                cin >> l >> r >> x;
                put(1, 0, N - 1, l, r, x);
            } else {
                ll v;
                cin >> v;
                s = 0;
                ll ans = dfs1(1, v, s) + 1;
                gt(1, 0, N - 1, v);
                if (now[v] == 0) {
                    ans += wd[ld[v]];
                }
                if (now[v] == 1) {
                    ans += wd[v] - 1;
                }
                cout << ans << '\n';
            }
        }
    } else {
        vector<ll> z;
        ll pr = 0;
        queue<node> qp;
        ll q1 = 0;
        for (int i = 0; i < q; ++i) {
            ll type;
            cin >> type;
            if (type == 1) {
                q1++;
                ll l, r, x;
                cin >> l >> r >> x;
                if (q <= 5000 || q1 <= 10 || (l == r && pr == 0)) {
                    qp.push({l, r, x});
                    for (int v = (int) l; v <= r; ++v) {
                        if (now[v] == x) {
                            continue;
                        }
                        if (now[v] == -1) add(1, 0, N - 1, tin[v] + 1, tout[v] - 1, -1);
                        if (now[v] == 0 && rd[v] != 0) add(1, 0, N - 1, tin[rd[v]], tout[rd[v]], -1);
                        now[v] = x;
                        if (now[v] == -1) add(1, 0, N - 1, tin[v] + 1, tout[v] - 1, 1);
                        if (now[v] == 0 && rd[v] != 0) add(1, 0, N - 1, tin[rd[v]], tout[rd[v]], 1);
                    }
                } else {
                    while (!qp.empty()) {
                        auto [l1, r1, x1] = qp.front();
                        put(1, 0, N - 1, l1, r1, x1);
                        qp.pop();
                    }
                    pr = 1;
                    put(1, 0, N - 1, l, r, x);
                }
            } else {
                ll v;
                cin >> v;
                if (pr == 0) {
                    ll ans = 0;
                    get(1, 0, N - 1, tin[v], ans);
                    if (now[v] == 0) {
                        ans += wd[ld[v]];
                    }
                    if (now[v] == 1) {
                        ans += wd[v] - 1;
                    }
                    cout << ans << '\n';
                } else {
                    if (pr == 1) {
                        pr = 2;
                        s = 0;
                        dfs2(1, s);
                    } else {
                        cout << cnt[v] << '\n';
                    }
                }
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}