#include <bits/stdc++.h>

#include <random>

using namespace std;

using ll = long long;

const ll N = 15;

ll n, m;
ll s;
ll a[N][N];

ll used;
stack<pair<ll, ll>> p;

void f() {
    ll s1 = 0;
    vector<pair<ll, ll>> b(m);
    for (int i = 0; i < m; ++i) {
        b[i].second = i;
        for (int j = 0; j < n; ++j) {
            if (((used >> j) & 1) == 0) {
                b[i].first += a[j][i];
            }
        }
        s1 += b[i].first;
    }
    if (s1 < s) {
        return;
    }
    std::shuffle(b.begin(), b.end(), std::mt19937(1));
    unordered_map<ll, ll> q1;
    unordered_map<ll, ll> q2;
    q1[0] = -1;
    q2[0] = -1;
    for (int i = 0; i < m / 2; ++i) {
        for (auto [sum, v]: q1) {
            p.emplace(sum + b[i].first, i);
        }
        while (!p.empty()) {
            auto [sum, v] = p.top();
            p.pop();
            if (!q1.count(sum) && sum <= s) q1[sum] = v;
        }
    }
    for (int i = (int) m / 2; i < m; ++i) {
        for (auto [sum, v]: q2) {
            p.emplace(sum + b[i].first, i);
        }
        while (!p.empty()) {
            auto [sum, v] = p.top();
            p.pop();
            if (!q2.count(sum) && sum <= s) q2[sum] = v;
        }
    }
    vector<ll> used1(m, 1);
    for (auto [sum, v]: q1) {
        if (q2.count(s - sum)) {
            cout << "YES" << '\n';
            ll sum1 = sum;
            ll sum2 = s - sum;
            while (sum1 != 0) {
                ll u = q1[sum1];
                used1[u] = 0;
                sum1 -= b[u].first;
            }
            while (sum2 != 0) {
                ll u = q2[sum2];
                used1[u] = 0;
                sum2 -= b[u].first;
            }
            vector<pair<ll, ll>> ans;
            for (int i = n - 1; i >= 0; --i) {
                if (((used >> i) & 1) == 1) {
                    ans.emplace_back(1, i + 1);
                }
            }
            for (int i = m - 1; i >= 0; --i) {
                if (used1[i]) {
                    ans.emplace_back(2, b[i].second + 1);
                }
            }
            cout << ans.size() << '\n';
            for (auto [x, y]: ans) {
                cout << x << " " << y << '\n';
            }
            exit(0);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    ll t = 1;
    for (int i = 0; i < 15; ++i) {
        t *= 2;
    }
    vector<ll> tp(t);
    for (int i = 0; i < t; ++i) {
        tp[i] = i;
    }
    std::shuffle(tp.begin(), tp.end(), std::mt19937(2));
    for (int i = 0; i < t; ++i) {
        if (i > 30000) {
            break;
        }
        used = tp[i];
        f();
    }
    cout << "NO";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    while (test--) {
        solve();
    }
    return 0;
}