#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 15;

ll n, m;
ll s;
ll a[N][N];

ll used[N];
ll b[N];

void f() {
    for (int i = 0; i < m; ++i) {
        b[i] = 0;
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                b[i] += a[j][i];
            }
        }
    }
    unordered_map<ll, ll> q1;
    unordered_map<ll, ll> q2;
    q1[0] = -1;
    q2[0] = -1;
    for (int i = 0; i < m / 2; ++i) {
        queue<pair<ll, ll>> p;
        for (auto [sum, v]: q1) {
            p.push({sum + b[i], i});
        }
        while (!p.empty()) {
            auto [sum, v] = p.front();
            p.pop();
            if (!q1.count(sum)) q1[sum] = v;
        }
    }
    for (int i = (int) m / 2; i < m; ++i) {
        queue<pair<ll, ll>> p;
        for (auto [sum, v]: q2) {
            p.push({sum + b[i], i});
        }
        while (!p.empty()) {
            auto [sum, v] = p.front();
            p.pop();
            if (!q2.count(sum)) q2[sum] = v;
        }
    }
    vector<ll> used1(m, 1);
    for (auto [sum, v]: q1) {
        if (q2.count(s - sum)) {
            if (n > 1) {
                while (true);
            }
            cout << "YES" << '\n';
            ll sum1 = sum;
            ll sum2 = s - sum;
            while (sum1 != 0) {
                ll u = q1[sum1];
                used1[u] = 0;
                sum1 -= b[u];
            }
            while (sum2 != 0) {
                ll u = q2[sum2];
                used1[u] = 0;
                sum2 -= b[u];
            }
            vector<pair<ll, ll>> ans;
            for (int i = n - 1; i >= 0; --i) {
                if (used[i]) {
                    ans.emplace_back(1, i + 1);
                }
            }
            for (int i = m - 1; i >= 0; --i) {
                if (used1[i]) {
                    ans.emplace_back(2, i + 1);
                }
            }
            cout << ans.size() << '\n';
            for (auto [x, y]: ans) {
                cout << x << " " << y << '\n';
            }
            exit(0);
        }
    }
}

void rec(ll i) {
    if (i == n) {
        f();
        return;
    }
    rec(i + 1);
    used[i] = 1;
    rec(i + 1);
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    rec(0);
    cout << "NO";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    while (test--) {
        solve();
    }
    return 0;
}