#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 1e6 + 1;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<pair<ll, ll>> pt;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pt.push_back({a[i], i});
    }
    std::sort(pt.begin(), pt.end());
    vector<ll> p;
    vector<ll> lp(N);
    for (int i = 2; i < N; ++i) {
        if (lp[i] == 0) {
            p.push_back(i);
            lp[i] = i;
        }
        for (ll u: p) {
            if (u * i >= N || u > lp[i]) {
                break;
            }
            lp[u * i] = u;
        }
    }
    unordered_map<ll, ll> q;
    for (auto [f, i]: pt) {
        ll pr = 0;
        while (f != 1) {
            if (q.count(a[i] / lp[f])) {
                pr = q[a[i] / lp[f]] ^ 1;
                if (rand() % 2 == 1) {
                    break;
                }
            }
            f /= lp[f];
        }
        q[a[i]] = pr;
        a[i] = pr;
    }
    for (int i = 0; i < n; ++i) {
        cout << a[i] + 1 << " ";
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}