#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 1e6 + 1;

vector<ll> p;
vector<ll> lp(N);
ll c[N];
vector<ll> g[N];

void dfs(ll v, ll k) {
    c[v] = k + 1;
    for (ll u: g[v]) {
        if (c[u] == 0) {
            dfs(u, k ^ 1);
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<pair<ll, ll>> pt;
    set<ll> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pt.push_back({a[i], i});
        q.insert(a[i]);
    }
    std::sort(pt.begin(), pt.end());
    for (int i = 2; i < N; ++i) {
        if (lp[i] == 0) {
            p.push_back(i);
            lp[i] = i;
        }
        for (ll u: p) {
            if (u * i >= N || u > lp[i]) {
                break;
            }
            lp[u * i] = u;
        }
    }
    for (auto [f, i]: pt) {
        while (f != 1) {
            if (q.count(a[i] / lp[f])) {
                g[a[i]].push_back(a[i] / lp[f]);
                g[a[i] / lp[f]].push_back(a[i]);
            }
            f /= lp[f];
        }
    }
    for (int i = 0; i < N; ++i) {
        if (!c[i]) {
            dfs(i, 0);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << c[a[i]] << " ";
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}