#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 1e6 + 1;

ll n, m;
vector<ll> a;
vector<ll> t;
vector<ll> p(60);

ll f(ll mid) {
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        if (mid >= a[i]) {
            sum += 1;
            if (a[i] + t[i] <= mid) {
                ll k = mid - a[i] - t[i] + 1;
                if (k > 40) {
                    sum = 1e12;
                    break;
                } else {
                    sum--;
                    sum += p[k];
                }
            }
        }
    }
    return sum;
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    t.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    p[0] = 1;
    for (int i = 1; i < 60; ++i) {
        p[i] = p[i - 1] * 2;
    }
    ll l = 0;
    ll r = 1e12;
    while (l < r - 1) {
        ll mid = (l + r) / 2;
        if (f(mid) <= m) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (f(l) == m) {
        cout << l;
    } else {
        cout << -1;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}