#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N = 2e5 + 5;

ll p[N * 4];
ll cnt[N];

ll tin[N];
ll tout[N];
ll ld[N];
ll rd[N];
ll wd[N];
ll t = 1;

void push(ll v, ll tl, ll tr) {
    if (tl == tr) {
        cnt[tl] += p[v];
    } else {
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }
    p[v] = 0;
}

void add(ll v, ll tl, ll tr, ll l, ll r, ll c) {
    push(v, tl, tr);
    if (tl > l || tr < l || l > r) {
        return;
    }
    if (tl >= l && tr <= r) {
        p[v] += c;
        push(v, tl, tr);
        return;
    }
    ll tm = (tl + tr) / 2;
    add(v * 2, tl, tm, l, r, c);
    add(v * 2 + 1, tm + 1, tr, l, r, c);
}

void get(ll v, ll tl, ll tr, ll k, ll &ans) {
    push(v, tl, tr);
    if (tl > k || tr < k) {
        return;
    }
    if (tl == tr) {
        ans = cnt[tl];
        return;
    }
    ll tm = (tl + tr) / 2;
    get(v * 2, tl, tm, k, ans);
    get(v * 2 + 1, tm + 1, tr, k, ans);
}

ll now[N];

void dfs(ll v, ll &s) {
    tin[v] = t++;
    wd[v] = 1;
    now[v] = -1;
    s++;
    cnt[tin[v]] = s;
    if (ld[v] != 0) {
        dfs(ld[v], s);
        wd[v] += wd[ld[v]];
    }
    if (rd[v] != 0) {
        dfs(rd[v], s);
        wd[v] += wd[rd[v]];
    }
    tout[v] = t++;
}

void solve() {
    ll n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> ld[i] >> rd[i];
    }
    ll root = 1;
    ll s = 0;
    dfs(root, s);
    for (int i = 0; i < q; ++i) {
        ll type;
        cin >> type;
        if (type == 1) {
            ll l, r, x;
            cin >> l >> r >> x;
            for (int v = (int) l; v <= r; ++v) {
                if (now[v] == x) {
                    continue;
                }
                if (now[v] == -1) add(1, 0, N - 1, tin[v] + 1, tout[v] - 1, -1);
                if (now[v] == 0) add(1, 0, N - 1, tin[rd[v]], tout[rd[v]], -1);
                now[v] = x;
                if (now[v] == -1) add(1, 0, N - 1, tin[v] + 1, tout[v] - 1, 1);
                if (now[v] == 0) add(1, 0, N - 1, tin[rd[v]], tout[rd[v]], 1);
            }
        } else {
            ll v;
            cin >> v;
            ll ans = 0;
            get(1, 0, N - 1, tin[v], ans);
            if (now[v] == 0) {
                ans += wd[ld[v]];
            }
            if (now[v] == 1) {
                ans += wd[v] - 1;
            }
            cout << ans << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}